unit JDMMenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, JDWndPrc;

type
  TJDMainMenu = class(TMainMenu)
  protected
    FOwnerHandle : longint; 
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;                     override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('JDComp', [TJDMainMenu]);
end;

constructor TJDMainMenu.Create(AOwner: TComponent);
var
   OwnerWndProc : longint;
   ProcFuncRec : PProcFuncRec;

begin
   inherited;

   if csDesigning in ComponentState then
      exit;

   OwnerWndProc := GetWindowLong(TWinControl(Owner).Handle, GWL_WNDPROC);
   ProcFuncRec := GetHandleRecord(TWinControl(Owner).Handle);

   if ProcFuncRec = nil then begin
      ProcFuncRec := AddHandleRecord( TWinControl(Owner).Handle, OwnerWndProc);
      OwnerWndProc := SetWindowLong(TWinControl(Owner).Handle, GWL_WNDPROC, longint(@StdWndProc));
      if OwnerWndProc = 0 then
         GetLastError;
   end;

   inc(ProcFuncRec^.FCount);
   ProcFuncRec^.IsMenu := true;

   FOwnerHandle := TWinControl(Owner).Handle;

end;

destructor  TJDMainMenu.Destroy;
var
   i : integer;

begin
   i := GetHandleRecordNum(FOwnerHandle);
   if i >= 0 then begin
      dec(PProcFuncRec(ActiveWndList[i])^.FCount);
      if PProcFuncRec(ActiveWndList[i])^.FCount = 0 then
         DelHandleRecordNum(i);
   end;

   inherited;
end;

end.
