unit JDSB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, JDWndPrc;

type
  TJDSpeedButton = class(TSpeedButton)
  private
    { Private declarations }
  protected
    FHelpContext : longint;
    FPopUpHelp   : boolean;
    FOwnerHandle : longint;

    procedure WndProc(var Message: TMessage); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy;                    override;
  published
    property  HelpContext : longint read FHelpContext write FHelpContext default 0;
    property  PopUpHelp   : boolean read FPopUpHelp   write FPopUpHelp   default true;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('JDComp', [TJDSpeedButton]);
end;

{*******************************************************************************}

constructor TJDSpeedButton.Create(AOwner: TComponent);
var
   OwnerWndProc : longint;
   ProcFuncRec : PProcFuncRec;

begin
   inherited;

   if csDesigning in ComponentState then
      exit;

   OwnerWndProc := GetWindowLong(TWinControl(Owner).Handle, GWL_WNDPROC);
   ProcFuncRec := GetHandleRecord(TWinControl(Owner).Handle);

   if ProcFuncRec = nil then begin
      ProcFuncRec := AddHandleRecord( TWinControl(Owner).Handle, OwnerWndProc);
      OwnerWndProc := SetWindowLong(TWinControl(Owner).Handle, GWL_WNDPROC, longint(@StdWndProc));
      if OwnerWndProc = 0 then
         GetLastError;
   end;

   inc(ProcFuncRec^.FCount);

   FOwnerHandle := TWinControl(Owner).Handle;

end;

destructor TJDSpeedButton.Destroy;
var
   i : integer;

begin
   i := GetHandleRecordNum(FOwnerHandle);
   if i >= 0 then begin
      dec(PProcFuncRec(ActiveWndList[i])^.FCount);
      if PProcFuncRec(ActiveWndList[i])^.FCount = 0 then
         DelHandleRecordNum(i);
   end;

   inherited;
end;

procedure TJDSpeedButton.WndProc(var Message: TMessage);
var
   HFNB : array [ 0..255] of char;
   ProcFuncRec : PProcFuncRec;

begin
   if (Message.Msg = WM_LBUTTONDOWN) and (not (csDesigning in ComponentState)) then begin
      ProcFuncRec := GetHandleRecord(FOwnerHandle);
      if ProcFuncRec = nil then
         exit;

      if ProcFuncRec^.IsContenxtHelp then begin
         ProcFuncRec^.IsContenxtHelp := false;
         if FHelpContext <> 0 then begin
            strplcopy(HFNB, Application.HelpFile, sizeof(HFNB));
{$IFDEF JDocs}
            Winhelp(TWinControl(Owner).Handle, HFNB, HELP_CONTEXTPOPUP, FHelpContext);
{$ELSE}
            if FPopUpHelp then
               Winhelp(TWinControl(Owner).Handle, HFNB, HELP_CONTEXTPOPUP, FHelpContext)
            else
               Winhelp(TWinControl(Owner).Handle, HFNB, HELP_CONTEXT, FHelpContext);
{$ENDIF}
         end;
         exit;
      end;
   end;

   inherited;
end;

end.
